#!/usr/bin/perl
##############################################################################
# cw.cgi                                                                     #
# [MV]DarkViper's PWD Script (created: 29.05.2000)                           #
#                                                                            #
# [MV]DarkViper                                                              #
# eMail   : webmaster@mvclan.de                                              #
# Homepage: www.mvclan.de                                                    #
# __________________________________________________________________________ #
# Copyright (C) by [MV]DarkViper (Thomas Pajor), 2000                        #
# Alle Rechte vorbehalten.                                                   #
#                                                                            #
#                                                                            #
# Lest euch die readme.htm bitte als erstes durch. Dort wird auch be-        #
# schrieben, wie das Skript installiert wird. Was die einzelnen Einstellung- #
# en bedeuten, wird bei der jeweiligen Einstellung selbst beschrieben!       #
#                                                                            #
##############################################################################
########################################### EINGEBUNDENE LIBRARIES ###########
use vars qw($req);
use CGI  qw(:cgi);
$req = new CGI;
##############################################################################
print "Content-type: text/html\n\n";
require "pwd.cfg"; # Einbinden der Konfigurationsdatei!
##############################################################################
##############################################################################
##############################################################################
##############################################################################

# HTML Kopf der Seite(n)
# Hier knnt ihr das Design anpassen!
$html_head = <<EOF;
 <html>
 <head>
 <title>Password Config for $file_pwd</title>
 <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
 <style type="text/css">
 <!--
   body,td,th,ul,caption,center,form,textarea,div,span { font-family:Arial, Helvetica; font-size:10pt; font-weight:normal; text-decoration:none }
   a { text-decoration:none }
   A:hover { text-decoration:underline overline }
   h1 { font-size:18pt; font-weight:bold; color=#3366FF; }
   h2 { font-weight:normal; font-size:8pt; }
   .tindex { font-weight:bold; font-size:12pt; }
 //-->
 </style>
EOF

##############################################################################

# HTML Body der Seite(n)
# Achtung: Das </head> tag NICHT lschen!
$html_body = <<EOF;
 </head>
 <body bgcolor="\#cccccc" text="\#000000" link="\#0000cc" vlink="\#0000cc" alink="\#0000cc">
EOF

##############################################################################

# HTML Fuss der Seite(n)
# Hier darf nichts verndert werden!!!!
$html_foot = <<EOF;
 <div align="center"><h2>
 Script by: <a href="mailto:webmaster\@mvclan.de">[MV]DarkViper</a><br>
 Website: <a href="http://www.mvclan.de" target="_blank">www.mvclan.de</a>
 </h2>
 </div>
 </body>
 </html>
EOF

##############################################################################
##############################################################################
##############################################################################
##############################################################################

get_input(); # Parameter abfragen!
action();

##############################################################################
#
# action: Hauptprogramm
#
##############################################################################
sub action
{
  if ($f_action eq 'view') { view(); }
  elsif ($f_action eq 'add') { add(); }
  elsif ($f_action eq 'post') { post(); }
  elsif ($f_action eq 'del') { del(); }
  elsif ($f_action eq 'edit') { edit(); }
  elsif ($f_action eq 'change') { change(); }
  elsif ($f_action eq 'reset') { reset_warning(); }
  elsif ($f_action eq 'reset_file') { reset_file(); } 
  elsif ($f_action eq 'send_pwd') { send_pwd(); }  
  else { view(); }
}


##############################################################################
#
# view: Anzeigen aller Benutzer ;-)
#
##############################################################################
sub view
{
 login();
 $html_nav = gennav();
 # Passwortdatei auslesen
 open (PWD, "<$file_pwd") || die error(no_file_pwd); my @a_passwd = <PWD>; close(PWD);  @a_passwd = sort { $a cmp $b } @a_passwd;
 
 # HTML ausgeben :)
 print <<EOF;
 $html_head
 $html_body
 <div align="center">
 <h1>Benutzer anzeigen, $f_login</h1>
 </div>
 $html_nav
 <div align="center">
  <table border=1 cellspacing=0 cellpadding=4>
  <tr bgcolor="#999999"><td bordercolor="#999999"><b>Name</b></td><td bordercolor="#999999"><b>eMail</b></td><td bordercolor="#999999"><b>Adminrechte</b></td><td bordercolor="#999999"><b>Optionen</b></td></tr>
EOF
 # Alle gagge hier ausegben ;-)
 foreach $passwdline (@a_passwd) {
  chomp($passwdline); ($s_login, $s_passwd, $b_crypt, $s_email, $s_admin) = split(/:/, $passwdline);
  if ($color eq '#bbbbbb') { $color = '#cccccc'; } else { $color = '#bbbbbb'; }
  if ($s_admin) { $admin = 'Ja'; } else { $admin = 'Nein'; }
  if ($s_login eq $f_login) { $sc_login = "<b>$s_login</b>"; } else { $sc_login = $s_login; }
  print "  <tr bgcolor=\"$color\"><td bordercolor=\"$color\">$sc_login</td><td bordercolor=\"$color\"><a href=\"mailto:$s_email\">$s_email</a></td><td bordercolor=\"$color\">$admin</td><td><a href=\"$url_script?action=edit&num=$s_login&login=$f_login&passwd=$f_passwd\">edit</a>, <a href=\"$url_scrip?action=del&num=$s_login&login=$f_login&passwd=$f_passwd\">delete</a></td></tr>"; 
 }
 print <<EOF;
  </table>
 </div>
 $html_foot
EOF
 exit; # rotfl
}


##############################################################################
#
# add: Hinzufuegen eines Benutzers
#
##############################################################################
sub add
{
 login(1);
 $html_nav = gennav();
 # Formular ausspucken
 print <<EOF;
 $html_head
 $html_body
 <div align="center"><h1>Benutzer hinzuf&uuml;gen, $f_login</h1></div>
 $html_nav
 <div align="center">
 <form method=POST action="$url_script" ENCTYPE="multipart/form-data">
 <input type=hidden name="action" value="post">
 <input type=hidden name="login" value="$f_login">
 <input type=hidden name="passwd" value="$f_passwd">
 <table border=0 cellspacing=0 cellpadding=4><tr><td>
 <table border=1 cellspacing=0 cellpadding=4>
  <tr bgcolor="#cccccc"><td bordercolor="#cccccc" class="tindex">Login-Name:</td><td bordercolor="#cccccc"><input type=text name="usrname"></td></tr>
  <tr bgcolor="#cccccc"><td bordercolor="#cccccc" class="tindex">eMail Addresse:</td><td bordercolor="#cccccc"><input type=text name="mail"></td></tr>
   <tr bgcolor="#999999"><td colspan="2" height="10"><font size="1">&nbsp;</font></td></tr>
  <tr bgcolor="#cccccc"><td bordercolor="#cccccc" class="tindex">Passwort:</td><td bordercolor="#cccccc"><input type=password name="passwd1"></td></tr>
  <tr bgcolor="#cccccc"><td bordercolor="#cccccc" class="tindex">Passwort-Besttigung:</td><td bordercolor="#cccccc"><input type=password name="passwd2"></td></tr>
   <tr bgcolor="#999999"><td colspan="2" height="10"><font size="1">&nbsp;</font></td></tr>
  <tr bgcolor="#cccccc"><td bordercolor="#cccccc" class="tindex">Optionen:</td>
   <td bordercolor="#cccccc"><input type=checkbox name="crypt"> Passwort verschl&uuml;sseln<br><input type=checkbox name="adminr"> Admin - Rechte<br><input type=checkbox name="inform"> Benutzer per eMail informieren<br></td></tr> 
 </table></td></tr><tr><td>
  <input type=submit value="&nbsp;Erstellen&nbsp">&nbsp;<input type=reset value="Zur&uuml;cksetzen">
 </td></tr></table></form>
 </div>
 $html_foot
EOF
 exit; 
}


##############################################################################
#
# post: User posten *g*
#
##############################################################################
sub post
{
 login(1);
 unless ($f_usrname && $f_mail && $f_passwd1 && $f_passwd2) { die error(form); }
 if (check_user($f_usrname)) { die error(usr_exists, $f_name); }
 unless ($f_passwd1 eq $f_passwd2) { die error(passwds); }
 
 # OKi, Zeile klarmachen *g*
 $s_salt = substr($f_usrname, 0, 2);
 if ($f_crypt eq 'on') { $s_passwd = crypt($f_passwd1, $s_salt); $f_crypt = 1; } else { $s_passwd = $f_passwd1; $f_crypt = 0; }
 if ($f_adminr eq 'on') { $f_adminr = 1; } else { $f_adminr = 0; }
 $line = "$f_usrname:$s_passwd:$f_crypt:$f_mail:$f_adminr\n";
 
 # Datenbank oeffnen fuer append ;)
 open(DB, ">>$file_pwd") || die error(no_file_pwd); print DB "$line"; close(DB);
 
 # Benutzer informieren, falls festgesetzt
 if ($f_inform eq 'on')
 {
  if ($f_adminr) { $f_adminr = 'Ja'; } else { $f_adminr = 'Nein'; }
  open (SENDMAIL, "| $path_sendmail -t");
  print SENDMAIL "To: $f_usrname <$f_mail>\n";
  print SENDMAIL "From: $path_script <$email_admin>\n";
  print SENDMAIL "Subject: Neuer Useraccount\n\n";
  print SENDMAIL <<EOF;
Hallo $f_usrname,

soeben wurde ein neuer Benutzeraccount auf diesen Namen angelegt. Du erhaelst somit folgende Login-Daten:

Benutzername: $f_usrname
Passwort: $f_passwd1
Adminberechtigung: $f_adminr

Du solltest als erstes Dein Passwort ndern, logge dich dazu ein, und klicke bei deinem Namen auf 'edit'.
Viel Spass weiterhin mit deinem Account

MFG, $f_login
--------------------------------
User - Skript by: [MV]DarkViper
eMail: webmaster\@mvclan.de
Webpage: www.mvclan.de
EOF
  close (SENDMAIL);
 }
 
 redirection("Benutzer $f_usrname erfolgreich angelegt.", "view&login=$f_login&passwd=$f_passwd");
 exit;
}


##############################################################################
#
# del: Benutzer loeschen
#
##############################################################################
sub del
{
 login(1);
 unless($f_num) { die error(no_param); }
 open (PWD, "<$file_pwd") || die error(no_file_pwd); my @a_passwd = <PWD>; close(PWD);
 open (PWD, ">$file_pwd");
 foreach $line (@a_passwd)
 {
  chomp($line); ($user, $rest) = split(/:/, $line);
  unless($user eq $f_num) { print PWD "$line\n"; }
 }
 close(PWD);
 
 unless ($f_num eq $f_login) { redirection("Benutzer $f_num erfolgreich gel&ouml;scht.", "view&login=$f_login&passwd=$f_passwd"); }
 else { redirection("Benutzer $f_num erfolgreich gel&ouml;scht."); }
 exit;
}


##############################################################################
#
# edit: Editieren eines Accounts
#
##############################################################################
sub edit
{
 login();
 unless($f_num) { die error(no_param); }
 if(($f_admin == 0) && ($f_num ne $f_login)) { die error(perm_denied, $f_login); }
 open (PWD, "<$file_pwd") || die error(no_file_pwd); my @a_passwd = <PWD>; close(PWD);
 
 # Zeilen durchsuchen, nach dem Eintrag
 foreach $line (@a_passwd)
 {
  chomp($line); ($s_login, $s_passwd, $b_crypt, $s_email, $s_admin) = split(/:/, $line);
  if ($f_num eq $s_login)
  {
   $html_nav = gennav();
   if ($b_crypt) { $c_crypt = 'checked'; }
   if ($s_admin) { $c_admin = 'checked'; }
   if ($f_admin) { $c_admin = "<input type=checkbox name=\"adminr\" $c_admin> Admin - Rechte<br>"; }
   if ($f_login eq $f_num) { $passwd =<<EOF;
        <tr bgcolor="#999999"><td colspan="2" height="10"><font size="1">&nbsp;</font></td></tr>
       <tr bgcolor="#cccccc"><td bordercolor="#cccccc" class="tindex">Passwort:</td><td bordercolor="#cccccc"><input type=password name="passwd1"></td></tr>
       <tr bgcolor="#cccccc"><td bordercolor="#cccccc" class="tindex">Passwort-Besttigung:</td><td bordercolor="#cccccc"><input type=password name="passwd2"></td></tr>
EOF
    $crypt = "<input type=checkbox name=\"crypt\" $c_crypt> Passwort verschl&uuml;sseln<br>";
   } else { $passwd_nochange = '<input type=hidden name="nochange" value="nochange">'; }
   print <<EOF;
    $html_head
    $html_body
    <div align="center"><h1>Benutzer editieren, $f_login</h1></div>
    $html_nav
    <div align="center">
    <form method=POST action="$url_script" ENCTYPE="multipart/form-data">
     <input type=hidden name="action" value="change">
     <input type=hidden name="login" value="$f_login">
     <input type=hidden name="passwd" value="$f_passwd">
     <input type=hidden name="login_old" value="$s_login">
     $passwd_nochange
     <table border=0 cellspacing=0 cellpadding=4><tr><td>
      <table border=1 cellspacing=0 cellpadding=4>
       <tr bgcolor="#cccccc"><td bordercolor="#cccccc" class="tindex">Login-Name:</td><td bordercolor="#cccccc"><input type=text name="usrname" value="$s_login"></td></tr>
       <tr bgcolor="#cccccc"><td bordercolor="#cccccc" class="tindex">eMail Addresse:</td><td bordercolor="#cccccc"><input type=text name="mail" value="$s_email"></td></tr>
       $passwd
        <tr bgcolor="#999999"><td colspan="2" height="10"><font size="1">&nbsp;</font></td></tr>
       <tr bgcolor="#cccccc"><td bordercolor="#cccccc" class="tindex">Optionen:</td>
        <td bordercolor="#cccccc">$crypt$c_admin<input type=checkbox name="inform"> Benutzer per eMail informieren<br></td></tr> 
      </table></td></tr><tr><td>
     <input type=submit value="&nbsp;Weiter&nbsp">&nbsp;<input type=reset value="Zur&uuml;cksetzen">
     </td></tr></table></form>
    </div>
    $html_foot
EOF
  }
 }
 exit;
}


##############################################################################
#
# change: Change One's User ;-)
#
##############################################################################
sub change
{
 login();
 unless ($f_nochange) { unless ($f_login_old && $f_usrname && $f_mail && $f_passwd1 && $f_passwd2) { die error(form); }}
 else { unless ($f_login_old && $f_usrname && $f_mail) { die error(form); } }
 if (check_user($f_usrname) && $f_usrname ne $f_login_old) { die error(usr_exists, $f_name); }
 unless ($f_nochange) { unless ($f_passwd1 eq $f_passwd2) { die error(passwds); } }
 
 # OKi, Zeile klarmachen *g*
 $s_salt = substr($f_usrname, 0, 2);
 if ($f_crypt eq 'on') { $s_passwd = crypt($f_passwd1, $s_salt); $f_crypt = 1; } else { $s_passwd = $f_passwd1; $f_crypt = 0; }
 if ($f_adminr eq 'on') { $f_adminr = 1; } else { $f_adminr = 0; }
 
 open (PWD, "<$file_pwd") || die error(no_file_pwd); my @a_passwd = <PWD>; close(PWD);
 open(DB, ">$file_pwd") || die error(no_file_pwd); 
 # Zeilen durchsuchen, nach dem Eintrag
 foreach $pwdline (@a_passwd)
 {
  chomp($pwdline); ($login, $passwd, $crypt, $email, $admin) = split(/:/, $pwdline);
  unless ($login eq $f_login_old) { print DB "$pwdline\n"; }
  else { unless($f_nochange) { print DB "$f_usrname:$s_passwd:$f_crypt:$f_mail:$f_adminr\n"; } else { print DB "$f_usrname:$passwd:$crypt:$f_mail:$f_adminr\n"; } }
 } close(DB);
 
 # Benutzer informieren, falls festgesetzt
 if ($f_inform eq 'on')
 {
  if ($f_adminr) { $f_adminr = 'Ja'; } else { $f_adminr = 'Nein'; }
  open (SENDMAIL, "| $path_sendmail -t");
  print SENDMAIL "To: User <$f_mail>\n";
  print SENDMAIL "From: $path_script <$email_admin>\n";
  print SENDMAIL "Subject: Useraccount Editiert\n\n";
  print SENDMAIL <<EOF;
Hallo $f_usrname,

soeben wurde Dein Benutzeraccount folgendermassen abgeaendert:

Benutzername: $f_usrname
eMail Adresse: $f_mail
Adminberechtigung: $f_adminr

Solltest Du diese aenderungen nicht selber vorgenommen haben, solltest Du als erstes Dein Passwort ndern, logge dich dazu ein, und klicke bei deinem Namen auf 'edit'.
Viel Spass weiterhin mit deinem Account

MFG, $f_login
--------------------------------
User - Skript by: [MV]DarkViper
eMail: webmaster\@mvclan.de
Webpage: www.mvclan.de
EOF
  close (SENDMAIL);
 }
 
 if ($f_login eq $f_login_old) { redirection("Benutzer $f_login_old erfolgreich abge&auml;ndert.", "view&login=$f_usrname&passwd=$f_passwd1"); }
 else { redirection("Benutzer $f_login_old erfolgreich abge&auml;ndert.", "view&login=$f_login&passwd=$f_passwd"); }
 exit;
}


##############################################################################
#
# resetwarning: Warnung ausspucken!
#
##############################################################################
sub reset_warning
{
 login(1);
 print <<EOF;
 $html_head
 $html_body
 <div align="center"><h1>Passwortdatei zur&uuml;cksetzen</h1></div>
 <p align="left"><font size="3">
 <b>Warnung:</b> Bei diesem Vorgang werden alle Benutzer aus der Passwortdatei entfernt, und es wird ein Standardbenutzer mit folgenden Login-Daten generiert:
 <blockquote>
  <i>Benutzername</i>: admin<br>
  <i>Passwort</i>: admin<br>
  <i>eMail</i>: $email_admin<br>
  <i>Adminrechte</i>: Ja<br>
 </blockquote>
 Dieser Vorgang kann nicht r&uuml;ckg&auml;ngig gemacht werden! Wollen Sie fortfahren?
 </font></p>
 <p align="left">
 <form method=POST action="$url_script" ENCTYPE="multipart/form-data">
 <input type=hidden name="login" value="$f_login">
 <input type=hidden name="passwd" value="$f_passwd">
 <input type=hidden name="action" value="reset_file">
 <input type=submit value="&nbsp;Fortfahren&nbsp;">&nbsp;<input type=button value="&nbsp;Zur&uuml;ck&nbsp;" onClick="javascrript:history.back ()">
 </form>
 </p>
 $html_foot
EOF
 exit;
}


##############################################################################
#
# resetfile: Lschen aller Benutzer & anlegen eines admin / admin benutzers
#
##############################################################################
sub reset_file
{
 login(1);
 # OKi, das geht jetzt schnell, was ?
 open(DB, ">$file_pwd") || die error(no_file_pwd); 
  print DB "admin:admin:0:$email_admin:1\n";
 close(DB);
 
 redirection("Die Passwortdatei wurde zur&uuml;ckgesetzt.");
 exit; 
}


##############################################################################
#
# gennav
#
##############################################################################
sub gennav
{
 $gen =<<EOF;
 <p align="center"><font size="2"><b>
   [ <a href="$url_script?action=view&login=$f_login&passwd=$f_passwd">User anzeigen</a> ] &#149; 
   [ <a href="$url_script?action=add&login=$f_login&passwd=$f_passwd">User hinzuf&uuml;gen</a> ] &#149; 
   [ <a href="$url_script?action=reset&login=$f_login&passwd=$f_passwd">Userdatei zur&uuml;cksetzen</a> ]</b></font>
 </p>
EOF
 return($gen);
}


##############################################################################
#
# check_user: Ueberpruefen ob ein Benutzer schon existiert
#
##############################################################################
sub check_user
{
 $user = $_[0];
 open (PWD, "<$file_pwd") || die error(no_file_pwd); my @passwds = <PWD>; close(PWD);
 foreach $line (@passwds) { ($usr, $rest) = split(/:/, $line); if ($usr eq $user) { return(1); } }
 return(0);
}


##############################################################################
#
# redirection: Weiterleitungsseite ausgeben
#
##############################################################################
sub redirection
{
  $param = $_[1];
  unless ($param) {$param = 'view'};
  # Dies ist nur HTML zeugs
  print <<EOF;
  $html_head
  <meta http-equiv="refresh" content="3; URL=$url_script?action=$param">
  $html_body
  <div align="center"><h1><b>$_[0]</b></h1>
  <b>Bitte auf Weiterleitung warten.</b></div>
  $html_foot
EOF
}


##############################################################################
#
# login: Einloggen, bzw. berprfen von pwd / loginname
#
##############################################################################
sub login
{
  $logintype = $_[0];
  unless ($logintype) { $logintype = 0; }
  # Passwortdatei auslesen
  open (PWD, "<$file_pwd") || die error(no_file_pwd); my @a_passwd = <PWD>; close(PWD);
  @a_passwd = sort { $a cmp $b } @a_passwd;
  
  # OK, erstmal checken, ob wir schon eingeloggt sind
  unless ($f_login && $f_passwd)
  {
    if ($f_num ne '') { $htmlnum = "<input type=hidden name=\"num\" value=\"$f_num\">"; } else { $htmlnum = ''; }
    # OK, hier einfach ein formular ausgeben
    print <<EOF;
    $html_head
    $html_body
     <div align="center">
      <table width="100" border="0" cellspacing="0" cellpadding="4"><form method=POST action="$url_script" ENCTYPE="multipart/form-data"><tr><td>
       <div align="center"><h1>Benutzerlogin</h1></div>
       <table border="1" cellspacing="0" cellpadding="4">
        <tr bgcolor="#999999">
         <td bordercolor="#999999" class="tindex">Username:</td>
         <td bordercolor="#999999"><select name="login">
EOF

    # Generieren der Benutzernamen ;-)
    foreach $passwdline (@a_passwd) {
      chomp($passwdline); ($s_login, $s_passwd, $b_crypt, $f_email, $f_admin) = split(/:/, $passwdline);
      print "         <option value=\"$s_login\">$s_login</option>\n";
    }
    
    print <<EOF;
         </select></td>
        </tr>
        <tr bgcolor="#cccccc">
         <td bordercolor="#cccccc" class="tindex">Passwort:</td>
         <td bordercolor="#cccccc"><input type=password name="passwd"></td>
        </tr>
       </table></td></tr><tr><td>
       <input type=submit value="&nbsp;Einloggen&nbsp;">&nbsp;<input type=reset value="Zur&uuml;cksetzen">
       
      </td></tr></form></table>
     </div>
    $html_foot
EOF
    exit;
  }
  
  foreach $passwdline (@a_passwd) {  
    chomp($passwdline); ($s_login, $s_passwd, $b_crypt, $f_email, $f_admin) = split(/:/, $passwdline);
    $s_salt = substr($f_login, 0, 2); # Schlssel definieren ;)
    if ($b_crypt == 1) {$s_testpwd = crypt($f_passwd, $s_salt);} else {$s_testpwd = $f_passwd;}
    if (($s_testpwd eq $s_passwd) && ($f_login eq $s_login)) { 
    if ($logintype == 1 && $f_admin == 0) { die error(perm_denied, $f_login); }
    return } # berprfung der PWDs & Benutzernamen
  }
  
  # Fehler spucken, wenn das Login falsch ist
  # Aber vorher ne eMail senden *g* ;-)
  ($time_sec,$time_min,$time_hour,$time_mday,$time_mon,$time_year,$time_wday,$time_yday,$time_isdst) = localtime(time); $time_year += 1900; $time_wday += 1; $time_mon += 1;
  open (SENDMAIL, "| $path_sendmail -t");
  print SENDMAIL "To: Webmaster <$email_admin>\n";
  print SENDMAIL "From: $path_script <$email_admin>\n";
  print SENDMAIL "Subject: Falsche Passworteingabe\n\n";
  print SENDMAIL <<EOF;
Warnung:
Fuer den Adminbereich des Userskriptes wurde eine falsche Login / Passwort - Kombination eingegeben:

Username: $f_login
Passwort: $f_passwd
IP: $ENV{'REMOTE_ADDR'}
Browser: $ENV{'HTTP_USER_AGENT'}
Datum: $time_mday.$time_mon.$time_year, $time_hour:$time_min.$time_sec

Sollten solche Vorfaelle oefters vorkommen, so ist eine haeufigere Aenderung von Benutzername / Kennwort empfohlen.
Fuer weitere Fragen kontakten Sie bitte [MV]DarkViper.
--------------------------------
Clanwars - Skript by: [MV]DarkViper
eMail: webmaster\@mvclan.de
Webpage: www.mvclan.de
EOF
  close (SENDMAIL);
  die error(wrong_login);
}


##############################################################################
#
# error: Auswertfunktion fuer Fehler...
#
##############################################################################
sub error
{
 $error = $_[0];
 
 if ($error eq 'wrong_login') { $err_content = "Die Kombination von Benutzername und Kennwort war ung&uuml;ltig. Der Webmaster wurde informiert."; }
 elsif ($error eq 'perm_denied') { $err_content = "<b>Permission Denied:</b> Der Benutzer $_[1] hat nicht die Berechtigung die gew&uuml;nschte Operation durchzuf&uuml;hren."; }
 elsif ($error eq 'no_param') { $err_content = "Es wurden nicht gen&uuml;gend Parameter dem Skript &uuml;bergeben. M&ouml;glicherweise liegt ein Skriptfehler vor. Bitte <a href=\"mailto:webmaster\@mvclan.de\">Urheber</a> kontakten!"; }
 elsif ($error eq 'no_file_pwd') { $err_content = "Die Passwortdatei $file_pwd konnte nich ge&ouml;ffnet werden, m&ouml;glicherweise ist der chmod falsch."; }
 elsif ($error eq 'form') { $err_content = "Es wurden nicht alle Felder in dem vorherigen Formular ausgef&uuml;llt. Bitte den 'Zur&uuml;ck'-Button des Browsers dr&uuml;cken, um zur Eingabe zur&uuml;ckzukehren."; }
 elsif ($error eq 'usr_exists') { $err_content = "Der User $_[1] existiert bereits. Bitte den Namen ab&auml;ndern."; }
 elsif ($error eq 'passwds') { $err_content = "Das Best&auml;tigungspasswort stimmt nicht mit dem Originalpasswort &uuml;berein. Bitte den 'Zur&uuml;ck'-Button des Browsers dr&uuml;cken, um zur Eingabe zur&uuml;ckzukehren."; }
 else { $err_content = "Es ist ein unbekannter Fehler aufgetreten. M&ouml;glicherweise liegt ein Scriptfehler vor."; }
 
 print <<EOF;
 $html_head
 $html_body
 <div align="left">
 <h1>Error in $url_script</h1>
 <br><blockquote class="tindex">
  <b>$err_content</b>
 </blockquote><br>
 Bitte konsultieren Sie den <a href="mailto:$email_admin">Webmaster</a> der Site, oder den <a href="mailto:webmaster\@mvclan.de">Urheber</a> des Skriptes, und informieren Sie ihn mit der genauen Fehlermeldung.
 <hr>
 <b>Server at:</b> $ENV{'HTTP_HOST'}<br>
 <b>Admin:</b> <a href="mailto:$ENV{'SERVER_ADMIN'}">$ENV{'SERVER_ADMIN'}</a><br>
 <b>Webmaster:</b> <a href="mailto:$email_admin">$email_admin</a>
 </div>
 $html_foot
EOF
}

##############################################################################
#
# get_input: Retrieve the Parameters! This is sucky complicated :(
#
##############################################################################
sub get_input
{
  # schlussendlich kann man noch die vars kopieren ;) *g*
  $f_action = $req->param('action');
  $f_login = $req->param('login');
  $f_passwd = $req->param('passwd');
  $f_num = $req->param('num');
  
  $f_usrname = $req->param('usrname');
  $f_login_old = $req->param('login_old');
  $f_mail = $req->param('mail');
  $f_passwd1 = $req->param('passwd1');
  $f_passwd2 = $req->param('passwd2');
  $f_crypt = $req->param('crypt');
  $f_adminr = $req->param('adminr');
  $f_inform = $req->param('inform');
  
  $f_nochange = $req->param('nochange');
}